Index: pjproject/trunk/tests/automated/configure.py
===================================================================
--- pjproject/trunk/tests/automated/configure.py	(revision 6022)
+++ pjproject/trunk/tests/automated/configure.py	(revision 6023)
@@ -31,5 +31,5 @@
             break
     proc.wait()
-    return "gcc-" + ver
+    return "gcc" + ver
 
 #
Index: pjproject/trunk/tests/automated/gnu-ipp.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu-ipp.xml.template	(revision 6022)
+++ pjproject/trunk/tests/automated/gnu-ipp.xml.template	(revision 6023)
@@ -19,5 +19,5 @@
 ]]>			
 		</FileWrite>
-		<Configure cmd='make distclean &amp;&amp; ./aconfigure --enable-ipp --with-ipp="$(IPPROOT)" --with-ipp-samples="$(IPPSAMPLES)" --with-ipp-arch=$(IPPARCH)' />
+		<Configure cmd='make distclean &amp;&amp; ./aconfigure --enable-ipp --with-ipp="$(IPPROOT)" --with-ipp-samples="$(IPPSAMPLES)" --with-ipp-arch=$(IPPARCH) --with-ssl=/Users/pjsip/Desktop/opt' />
 		<Build cmd="make dep &amp;&amp; make clean &amp;&amp; make" />
 		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" disabled=$(NOTEST) />
Index: pjproject/trunk/tests/automated/gnu-video-ffmpeg.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu-video-ffmpeg.xml.template	(revision 6023)
+++ pjproject/trunk/tests/automated/gnu-video-ffmpeg.xml.template	(revision 6023)
@@ -0,0 +1,31 @@
+<?xml version="1.0" ?>
+<Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
+ 
+	<Submit group="Experimental" build="$(SUFFIX)-$(GCC)-VideoFFmpeg-IPv6-G7221-DTLS" exclude="(.*amr.*)">
+		<Update />
+		<FileWrite file="user.mak">
+		  <![CDATA[
+# Written by ccdash
+export CFLAGS += -Wno-unused-label -g
+]]>			
+		</FileWrite>
+		<FileWrite file="pjlib/include/pj/config_site.h">
+		  <![CDATA[
+/* Written by ccdash */
+#define PJ_HAS_IPV6		1
+#define PJMEDIA_HAS_VIDEO	1
+#define PJMEDIA_HAS_G7221_CODEC 1
+#define PJMEDIA_SRTP_HAS_DTLS	1
+]]>			
+		</FileWrite>
+		<Configure cmd="make distclean &amp;&amp; ./configure-ffmpeg" />
+		<Build cmd="make dep &amp;&amp; make clean &amp;&amp; make" />
+		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjlib-util-test" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjnath-test" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjmedia-test" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" disabled=$(NOTEST) />
+		<Test name="pjsip-test" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" disabled=$(NOTEST) />
+		$(PJSUA-TESTS)
+	</Submit>
+	
+</Scenario>
Index: pjproject/trunk/tests/automated/gnu-video.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu-video.xml.template	(revision 6022)
+++ pjproject/trunk/tests/automated/gnu-video.xml.template	(revision 6023)
@@ -2,10 +2,10 @@
 <Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
  
-	<Submit group="Experimental" build="$(SUFFIX)-$(GCC)-VideoFFmpeg-IPv6" exclude="(.*amr.*)">
+	<Submit group="Experimental" build="$(SUFFIX)-$(GCC)-VideoOpenh264-IPv6-G7221-DTLS" exclude="(.*amr.*)">
 		<Update />
 		<FileWrite file="user.mak">
 		  <![CDATA[
 # Written by ccdash
-export CFLAGS += -Wno-unused-label -g -Wno-deprecated-declarations
+export CFLAGS += -Wno-unused-label -g
 ]]>			
 		</FileWrite>
Index: pjproject/trunk/tests/automated/gnu.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu.xml.template	(revision 6022)
+++ pjproject/trunk/tests/automated/gnu.xml.template	(revision 6023)
@@ -13,7 +13,8 @@
 		  <![CDATA[
 /* Written by ccdash */
-#define PJ_HAS_IPV6		1
-#define PJMEDIA_HAS_G7221_CODEC 1
-#define PJMEDIA_SRTP_HAS_DTLS	1
+#define PJ_HAS_IPV6		0	
+#define PJMEDIA_HAS_VIDEO	0
+#undef PJ_HAS_SSL_SOCK
+#define PJ_HAS_SSL_SOCK		0
 ]]>			
 		</FileWrite>
Index: pjproject/trunk/tests/automated/prepare.xml.template
===================================================================
--- pjproject/trunk/tests/automated/prepare.xml.template	(revision 6022)
+++ pjproject/trunk/tests/automated/prepare.xml.template	(revision 6023)
@@ -6,5 +6,5 @@
 		<Build cmd="$(NOP)" />
 
-		<!-- GNU Makefile based scenario 
+		<!-- GNU Makefile based (basic features) scenario 
 		     Requirement:
 		      - none
@@ -21,4 +21,13 @@
 		<Test name="Configuring GNU IPP scenario" cmd="python configure.py -t gnu -o gnu-ipp.xml gnu-ipp.xml.template" />
 
+                <!-- GNU Makefile with video scenario.
+                     Requirement:
+                      - OpenH264, or
+                      - ffmpeg
+                      - SDL
+                  -->
+                <Test name="Configuring 2.x VIDEO with OpenH264" cmd="python configure.py -t gnu -o gnu-video.xml gnu-video.xml.template" />
+                <Test name="Configuring 2.x VIDEO with ffmpeg" cmd="python configure.py -t gnu -o gnu-video-ffmpeg.xml gnu-video-ffmpeg.xml.template" />
+
 		<!-- iPhone target.
 		     Requriement(s):
@@ -28,4 +37,26 @@
 		<Test name="Configuring iPhone scenario" cmd="python configure.py -t gnu -o iphone.xml iphone.xml.template" />
 
+                <!-- iPhone 64 bit target.
+                     Requriement(s):
+                      - valid SDK is installed
+                 -->
+                <Test name="Configuring iPhone 64bit scenario" cmd="python configure.py -t gnu -o iphone64.xml iphone64.xml.template" />
+                <Test name="Configuring iPhone 64bit with IPv6 scenario" cmd="python configure.py -t gnu -o iphone64-ipv6.xml iphone64-ipv6.xml.template" />
+
+                <!-- Android target.
+                     Requriement(s):
+                      - valid NDK & SDK is installed
+                      - SWIG
+                 -->
+                <Test name="Configuring Android scenario" cmd="python configure.py -t gnu -o android.xml android.xml.template" />
+
+                <!-- Android 64 bit target.
+                     Requriement(s):
+                      - valid NDK & SDK is installed
+                      - SWIG
+                 -->
+                <Test name="Configuring Android 64bit scenario" cmd="python configure.py -t gnu -o android64.xml android64.xml.template" />
+                <Test name="Configuring Android 64bit with IPv6 scenario" cmd="python configure.py -t gnu -o android64-ipv6.xml android64-ipv6.xml.template" />
+
 		<!-- MSVC target.
 		     Requirements:
@@ -34,5 +65,5 @@
 
 		 -->
-		<Test name="Configuring Visual Studio for Win32" cmd="python configure.py -t vs -vstarget Release -o msvc-win32.xml -nopjsuatest msvc.xml.template" />
+		<!--Test name="Configuring Visual Studio for Win32" cmd="python configure.py -t vs -vstarget Release -o msvc-win32.xml -nopjsuatest msvc.xml.template" /-->
 
 		<!-- Symbian target.
@@ -40,5 +71,5 @@
 		       - EPOCROOT (modify below)
 		-->
-		<Test name="Configuring Symbian scenario" cmd='CMD /C SET EPOCROOT=\S60\devices\S60_5th_Edition_SDK_v1.0&amp;&amp; devices -setdefault @S60_5th_Edition_SDK_v1.0:com.nokia.s60&amp;&amp; python configure.py -t s60 -s60target &quot;gcce urel&quot; -o symbian.xml symbian.xml.template' />
+		<!--Test name="Configuring Symbian scenario" cmd='CMD /C SET EPOCROOT=\S60\devices\S60_5th_Edition_SDK_v1.0&amp;&amp; devices -setdefault @S60_5th_Edition_SDK_v1.0:com.nokia.s60&amp;&amp; python configure.py -t s60 -s60target &quot;gcce urel&quot; -o symbian.xml symbian.xml.template' /-->
 
 	</Submit>