Index: pjproject/trunk/pjsip/src/pjsua2/media.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsua2/media.cpp	(revision 5992)
+++ pjproject/trunk/pjsip/src/pjsua2/media.cpp	(revision 6026)
@@ -129,5 +129,5 @@
 }
 
-void AudioMedia::registerMediaPort(MediaPort port) throw(Error)
+void AudioMedia::registerMediaPort(MediaPort port) PJSUA2_THROW(Error)
 {
     /* Check if media already added to Conf bridge. */
@@ -157,5 +157,5 @@
 
 void AudioMedia::registerMediaPort2(MediaPort port, pj_pool_t *pool)
-     throw(Error)
+     PJSUA2_THROW(Error)
 {
     /* Check if media already added to Conf bridge. */
@@ -194,5 +194,5 @@
 }
 
-ConfPortInfo AudioMedia::getPortInfo() const throw(Error)
+ConfPortInfo AudioMedia::getPortInfo() const PJSUA2_THROW(Error)
 {
     return AudioMedia::getPortInfoFromId(id);
@@ -204,5 +204,5 @@
 }
 
-ConfPortInfo AudioMedia::getPortInfoFromId(int port_id) throw(Error)
+ConfPortInfo AudioMedia::getPortInfoFromId(int port_id) PJSUA2_THROW(Error)
 {
     pjsua_conf_port_info pj_info;
@@ -214,5 +214,5 @@
 }
 
-void AudioMedia::startTransmit(const AudioMedia &sink) const throw(Error)
+void AudioMedia::startTransmit(const AudioMedia &sink) const PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_conf_connect(id, sink.id) );
@@ -221,5 +221,5 @@
 void AudioMedia::startTransmit2(const AudioMedia &sink,
 				const AudioMediaTransmitParam &param) const
-     throw(Error)
+     PJSUA2_THROW(Error)
 {
     pjsua_conf_connect_param pj_param;
@@ -230,20 +230,20 @@
 }
 
-void AudioMedia::stopTransmit(const AudioMedia &sink) const throw(Error)
+void AudioMedia::stopTransmit(const AudioMedia &sink) const PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_conf_disconnect(id, sink.id) );
 }
 
-void AudioMedia::adjustRxLevel(float level) throw(Error)
+void AudioMedia::adjustRxLevel(float level) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_conf_adjust_tx_level(id, level) );
 }
 
-void AudioMedia::adjustTxLevel(float level) throw(Error)
+void AudioMedia::adjustTxLevel(float level) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_conf_adjust_rx_level(id, level) );
 }
 
-unsigned AudioMedia::getRxLevel() const throw(Error)
+unsigned AudioMedia::getRxLevel() const PJSUA2_THROW(Error)
 {
     unsigned level;
@@ -252,5 +252,5 @@
 }
 
-unsigned AudioMedia::getTxLevel() const throw(Error)
+unsigned AudioMedia::getTxLevel() const PJSUA2_THROW(Error)
 {
     unsigned level;
@@ -282,5 +282,5 @@
 void AudioMediaPlayer::createPlayer(const string &file_name,
 				    unsigned options)
-				    throw(Error)
+				    PJSUA2_THROW(Error)
 {
     if (playerId != PJSUA_INVALID_ID) {
@@ -318,5 +318,5 @@
 				      const string &label,
 				      unsigned options)
-				      throw(Error)
+				      PJSUA2_THROW(Error)
 {
     if (playerId != PJSUA_INVALID_ID) {
@@ -363,5 +363,5 @@
 }
 
-AudioMediaPlayerInfo AudioMediaPlayer::getInfo() const throw(Error)
+AudioMediaPlayerInfo AudioMediaPlayer::getInfo() const PJSUA2_THROW(Error)
 {
     AudioMediaPlayerInfo info;
@@ -379,5 +379,5 @@
 }
 
-pj_uint32_t AudioMediaPlayer::getPos() const throw(Error)
+pj_uint32_t AudioMediaPlayer::getPos() const PJSUA2_THROW(Error)
 {
     pj_ssize_t pos = pjsua_player_get_pos(playerId);
@@ -388,5 +388,5 @@
 }
 
-void AudioMediaPlayer::setPos(pj_uint32_t samples) throw(Error)
+void AudioMediaPlayer::setPos(pj_uint32_t samples) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_player_set_pos(playerId, samples) );
@@ -426,5 +426,5 @@
 				        long max_size,
 				        unsigned options)
-				        throw(Error)
+				        PJSUA2_THROW(Error)
 {
     PJ_UNUSED_ARG(max_size);
@@ -476,5 +476,6 @@
 
 void ToneGenerator::createToneGenerator(unsigned clock_rate,
-					unsigned channel_count) throw(Error)
+					unsigned channel_count)
+					PJSUA2_THROW(Error)
 {
     pj_status_t status;
@@ -504,5 +505,5 @@
 }
 
-void ToneGenerator::stop() throw(Error)
+void ToneGenerator::stop() PJSUA2_THROW(Error)
 {
     pj_status_t status;
@@ -516,5 +517,5 @@
 }
 
-void ToneGenerator::rewind() throw(Error)
+void ToneGenerator::rewind() PJSUA2_THROW(Error)
 {
     pj_status_t status;
@@ -529,5 +530,5 @@
 
 void ToneGenerator::play(const ToneDescVector &tones,
-                         bool loop) throw(Error)
+                         bool loop) PJSUA2_THROW(Error)
 {
     pj_status_t status;
@@ -546,5 +547,5 @@
 
 void ToneGenerator::playDigits(const ToneDigitVector &digits,
-                               bool loop) throw(Error)
+                               bool loop) PJSUA2_THROW(Error)
 {
     pj_status_t status;
@@ -557,10 +558,12 @@
     }
 
-    status = pjmedia_tonegen_play_digits(tonegen, (unsigned)digits.size(), &digits[0],
+    status = pjmedia_tonegen_play_digits(tonegen,
+					 (unsigned)digits.size(),
+					 &digits[0],
 					 loop? PJMEDIA_TONEGEN_LOOP : 0);
     PJSUA2_CHECK_RAISE_ERROR2(status, "ToneGenerator::playDigits()");
 }
 
-ToneDigitMapVector ToneGenerator::getDigitMap() const throw(Error)
+ToneDigitMapVector ToneGenerator::getDigitMap() const PJSUA2_THROW(Error)
 {
     const pjmedia_tone_digit_map *pdm;
@@ -594,5 +597,5 @@
 
 void ToneGenerator::setDigitMap(const ToneDigitMapVector &digit_map)
-				throw(Error)
+				PJSUA2_THROW(Error)
 {
     unsigned i;
@@ -682,10 +685,10 @@
 }
 
-int AudDevManager::getCaptureDev() const throw(Error)
+int AudDevManager::getCaptureDev() const PJSUA2_THROW(Error)
 {
     return getActiveDev(true);
 }
 
-AudioMedia &AudDevManager::getCaptureDevMedia() throw(Error)
+AudioMedia &AudDevManager::getCaptureDevMedia() PJSUA2_THROW(Error)
 {
     if (!devMedia)
@@ -694,10 +697,10 @@
 }
 
-int AudDevManager::getPlaybackDev() const throw(Error)
+int AudDevManager::getPlaybackDev() const PJSUA2_THROW(Error)
 {
     return getActiveDev(false);
 }
 
-AudioMedia &AudDevManager::getPlaybackDevMedia() throw(Error)
+AudioMedia &AudDevManager::getPlaybackDevMedia() PJSUA2_THROW(Error)
 {
     if (!devMedia)
@@ -706,5 +709,5 @@
 }
 
-void AudDevManager::setCaptureDev(int capture_dev) const throw(Error)
+void AudDevManager::setCaptureDev(int capture_dev) const PJSUA2_THROW(Error)
 {    
     pjsua_snd_dev_param param;
@@ -726,5 +729,5 @@
 }
 
-void AudDevManager::setPlaybackDev(int playback_dev) const throw(Error)
+void AudDevManager::setPlaybackDev(int playback_dev) const PJSUA2_THROW(Error)
 {
     pjsua_snd_dev_param param;
@@ -746,5 +749,5 @@
 }
 
-const AudioDevInfoVector &AudDevManager::enumDev() throw(Error)
+const AudioDevInfoVector &AudDevManager::enumDev() PJSUA2_THROW(Error)
 {
     pjmedia_aud_dev_info pj_info[MAX_DEV_COUNT];
@@ -764,5 +767,5 @@
 }
 
-AudioDevInfoVector2 AudDevManager::enumDev2() const throw(Error)
+AudioDevInfoVector2 AudDevManager::enumDev2() const PJSUA2_THROW(Error)
 {
     pjmedia_aud_dev_info pj_info[MAX_DEV_COUNT];
@@ -781,5 +784,5 @@
 }
 
-void AudDevManager::setNullDev() throw(Error)
+void AudDevManager::setNullDev() PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_set_null_snd_dev() );
@@ -791,5 +794,5 @@
 }
 
-void AudDevManager::setSndDevMode(unsigned mode) const throw(Error)
+void AudDevManager::setSndDevMode(unsigned mode) const PJSUA2_THROW(Error)
 {    
     int capture_dev = 0, playback_dev = 0;
@@ -807,10 +810,10 @@
 
 void AudDevManager::setEcOptions(unsigned tail_msec,
-				 unsigned options) throw(Error)
+				 unsigned options) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_set_ec(tail_msec, options) );
 }
 
-unsigned AudDevManager::getEcTail() const throw(Error)
+unsigned AudDevManager::getEcTail() const PJSUA2_THROW(Error)
 {
     unsigned tail_msec = 0;
@@ -826,5 +829,5 @@
 }
 
-void AudDevManager::refreshDevs() throw(Error)
+void AudDevManager::refreshDevs() PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjmedia_aud_dev_refresh() );
@@ -837,5 +840,5 @@
 
 AudioDevInfo
-AudDevManager::getDevInfo(int id) const throw(Error)
+AudDevManager::getDevInfo(int id) const PJSUA2_THROW(Error)
 {
     AudioDevInfo dev_info;
@@ -849,5 +852,5 @@
 
 int AudDevManager::lookupDev(const string &drv_name,
-			     const string &dev_name) const throw(Error)
+			     const string &dev_name) const PJSUA2_THROW(Error)
 {
     pjmedia_aud_dev_index pj_idx = 0;
@@ -868,5 +871,5 @@
 void
 AudDevManager::setExtFormat(const MediaFormatAudio &format,
-			    bool keep) throw(Error)
+			    bool keep) PJSUA2_THROW(Error)
 {
     pjmedia_format pj_format = format.toPj();
@@ -877,5 +880,5 @@
 }
 
-MediaFormatAudio AudDevManager::getExtFormat() const throw(Error)
+MediaFormatAudio AudDevManager::getExtFormat() const PJSUA2_THROW(Error)
 {
     pjmedia_format pj_format;
@@ -891,5 +894,5 @@
 
 void AudDevManager::setInputLatency(unsigned latency_msec,
-				    bool keep) throw(Error)
+				    bool keep) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_snd_set_setting(PJMEDIA_AUD_DEV_CAP_INPUT_LATENCY,
@@ -898,5 +901,5 @@
 }
 
-unsigned AudDevManager::getInputLatency() const throw(Error)
+unsigned AudDevManager::getInputLatency() const PJSUA2_THROW(Error)
 {
     unsigned latency_msec = 0;
@@ -910,5 +913,5 @@
 void
 AudDevManager::setOutputLatency(unsigned latency_msec,
-				bool keep) throw(Error)
+				bool keep) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_snd_set_setting(PJMEDIA_AUD_DEV_CAP_OUTPUT_LATENCY,
@@ -917,5 +920,5 @@
 }
 
-unsigned AudDevManager::getOutputLatency() const throw(Error)
+unsigned AudDevManager::getOutputLatency() const PJSUA2_THROW(Error)
 {
     unsigned latency_msec = 0;
@@ -927,5 +930,6 @@
 }
 
-void AudDevManager::setInputVolume(unsigned volume, bool keep) throw(Error)
+void AudDevManager::setInputVolume(unsigned volume, bool keep)
+				   PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR(
@@ -935,5 +939,5 @@
 }
 
-unsigned AudDevManager::getInputVolume() const throw(Error)
+unsigned AudDevManager::getInputVolume() const PJSUA2_THROW(Error)
 {
     unsigned volume = 0;
@@ -946,5 +950,6 @@
 }
 
-void AudDevManager::setOutputVolume(unsigned volume, bool keep) throw(Error)
+void AudDevManager::setOutputVolume(unsigned volume, bool keep)
+				    PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR(
@@ -954,5 +959,5 @@
 }
 
-unsigned AudDevManager::getOutputVolume() const throw(Error)
+unsigned AudDevManager::getOutputVolume() const PJSUA2_THROW(Error)
 {
     unsigned volume = 0;
@@ -965,5 +970,5 @@
 }
 
-unsigned AudDevManager::getInputSignal() const throw(Error)
+unsigned AudDevManager::getInputSignal() const PJSUA2_THROW(Error)
 {
     unsigned signal = 0;
@@ -976,5 +981,5 @@
 }
 
-unsigned AudDevManager::getOutputSignal() const throw(Error)
+unsigned AudDevManager::getOutputSignal() const PJSUA2_THROW(Error)
 {
     unsigned signal = 0;
@@ -989,5 +994,5 @@
 void
 AudDevManager::setInputRoute(pjmedia_aud_dev_route route,
-			     bool keep) throw(Error)
+			     bool keep) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_snd_set_setting(PJMEDIA_AUD_DEV_CAP_INPUT_ROUTE,
@@ -996,5 +1001,5 @@
 }
 
-pjmedia_aud_dev_route AudDevManager::getInputRoute() const throw(Error)
+pjmedia_aud_dev_route AudDevManager::getInputRoute() const PJSUA2_THROW(Error)
 {
     pjmedia_aud_dev_route route = PJMEDIA_AUD_DEV_ROUTE_DEFAULT;
@@ -1008,5 +1013,5 @@
 void
 AudDevManager::setOutputRoute(pjmedia_aud_dev_route route,
-			      bool keep) throw(Error)
+			      bool keep) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_snd_set_setting(PJMEDIA_AUD_DEV_CAP_OUTPUT_ROUTE,
@@ -1015,5 +1020,6 @@
 }
 
-pjmedia_aud_dev_route AudDevManager::getOutputRoute() const throw(Error)
+pjmedia_aud_dev_route AudDevManager::getOutputRoute() const
+						    PJSUA2_THROW(Error)
 {
     pjmedia_aud_dev_route route = PJMEDIA_AUD_DEV_ROUTE_DEFAULT;
@@ -1025,5 +1031,5 @@
 }
 
-void AudDevManager::setVad(bool enable, bool keep) throw(Error)
+void AudDevManager::setVad(bool enable, bool keep) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_snd_set_setting(PJMEDIA_AUD_DEV_CAP_VAD,
@@ -1032,5 +1038,5 @@
 }
 
-bool AudDevManager::getVad() const throw(Error)
+bool AudDevManager::getVad() const PJSUA2_THROW(Error)
 {
     bool enable = false;
@@ -1042,5 +1048,5 @@
 }
 
-void AudDevManager::setCng(bool enable, bool keep) throw(Error)
+void AudDevManager::setCng(bool enable, bool keep) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_snd_set_setting(PJMEDIA_AUD_DEV_CAP_CNG,
@@ -1049,5 +1055,5 @@
 }
 
-bool AudDevManager::getCng() const throw(Error)
+bool AudDevManager::getCng() const PJSUA2_THROW(Error)
 {
     bool enable = false;
@@ -1059,5 +1065,5 @@
 }
 
-void AudDevManager::setPlc(bool enable, bool keep) throw(Error)
+void AudDevManager::setPlc(bool enable, bool keep) PJSUA2_THROW(Error)
 {
     PJSUA2_CHECK_EXPR( pjsua_snd_set_setting(PJMEDIA_AUD_DEV_CAP_PLC,
@@ -1066,5 +1072,5 @@
 }
 
-bool AudDevManager::getPlc() const throw(Error)
+bool AudDevManager::getPlc() const PJSUA2_THROW(Error)
 {
     bool enable = false;
@@ -1084,5 +1090,5 @@
 }
 
-int AudDevManager::getActiveDev(bool is_capture) const throw(Error)
+int AudDevManager::getActiveDev(bool is_capture) const PJSUA2_THROW(Error)
 {
     int capture_dev = 0, playback_dev = 0;
@@ -1173,5 +1179,5 @@
 }
 
-VideoWindowInfo VideoWindow::getInfo() const throw(Error)
+VideoWindowInfo VideoWindow::getInfo() const PJSUA2_THROW(Error)
 {
     VideoWindowInfo vwi;
@@ -1195,5 +1201,5 @@
 }
 
-VideoMedia VideoWindow::getVideoMedia() throw(Error)
+VideoMedia VideoWindow::getVideoMedia() PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1214,5 +1220,5 @@
 }
 
-void VideoWindow::Show(bool show) throw(Error)
+void VideoWindow::Show(bool show) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1223,5 +1229,5 @@
 }
 
-void VideoWindow::setPos(const MediaCoordinate &pos) throw(Error)
+void VideoWindow::setPos(const MediaCoordinate &pos) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1236,5 +1242,5 @@
 }
 
-void VideoWindow::setSize(const MediaSize &size) throw(Error)
+void VideoWindow::setSize(const MediaSize &size) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1249,5 +1255,5 @@
 }
 
-void VideoWindow::rotate(int angle) throw(Error)
+void VideoWindow::rotate(int angle) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1258,5 +1264,5 @@
 }
 
-void VideoWindow::setWindow(const VideoWindowHandle &win) throw(Error)
+void VideoWindow::setWindow(const VideoWindowHandle &win) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1327,5 +1333,5 @@
 }
 
-void VideoPreview::start(const VideoPreviewOpParam &param) throw(Error)
+void VideoPreview::start(const VideoPreviewOpParam &param) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1338,5 +1344,5 @@
 }
 
-void VideoPreview::stop() throw(Error)
+void VideoPreview::stop() PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1354,5 +1360,5 @@
 }
 
-VideoMedia VideoPreview::getVideoMedia() throw(Error)
+VideoMedia VideoPreview::getVideoMedia() PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1444,5 +1450,5 @@
 
 ///////////////////////////////////////////////////////////////////////////////
-void VidDevManager::refreshDevs() throw(Error)
+void VidDevManager::refreshDevs() PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1460,5 +1466,5 @@
 }
 
-VideoDevInfo VidDevManager::getDevInfo(int dev_id) const throw(Error)
+VideoDevInfo VidDevManager::getDevInfo(int dev_id) const PJSUA2_THROW(Error)
 {
     VideoDevInfo dev_info;
@@ -1475,5 +1481,5 @@
 }
 
-const VideoDevInfoVector &VidDevManager::enumDev() throw(Error)
+const VideoDevInfoVector &VidDevManager::enumDev() PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1495,5 +1501,5 @@
 }
 
-VideoDevInfoVector2 VidDevManager::enumDev2() const throw(Error)
+VideoDevInfoVector2 VidDevManager::enumDev2() const PJSUA2_THROW(Error)
 {
     VideoDevInfoVector2 vdiv2;
@@ -1514,5 +1520,5 @@
 
 int VidDevManager::lookupDev(const string &drv_name,
-			     const string &dev_name) const throw(Error)
+			     const string &dev_name) const PJSUA2_THROW(Error)
 {
     pjmedia_vid_dev_index pj_idx = 0;
@@ -1541,5 +1547,5 @@
 void VidDevManager::setFormat(int dev_id,
 			      const MediaFormatVideo &format,
-			      bool keep) throw(Error)
+			      bool keep) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1557,5 +1563,6 @@
 }
 
-MediaFormatVideo VidDevManager::getFormat(int dev_id) const throw(Error)
+MediaFormatVideo VidDevManager::getFormat(int dev_id) const
+					  PJSUA2_THROW(Error)
 {
     MediaFormatVideo vid_format;
@@ -1575,5 +1582,5 @@
 void VidDevManager::setInputScale(int dev_id,
 				  const MediaSize &scale,
-				  bool keep) throw(Error)
+				  bool keep) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1592,5 +1599,5 @@
 }
 
-MediaSize VidDevManager::getInputScale(int dev_id) const throw(Error)
+MediaSize VidDevManager::getInputScale(int dev_id) const PJSUA2_THROW(Error)
 {
     MediaSize scale;
@@ -1612,5 +1619,5 @@
 void VidDevManager::setOutputWindowFlags(int dev_id, 
 					 int flags, 
-					 bool keep) throw(Error)
+					 bool keep) PJSUA2_THROW(Error)
 {    
 #if PJSUA_HAS_VIDEO    
@@ -1626,5 +1633,5 @@
 }
 
-int VidDevManager::getOutputWindowFlags(int dev_id) throw(Error)
+int VidDevManager::getOutputWindowFlags(int dev_id) PJSUA2_THROW(Error)
 {
     int flags = 0;
@@ -1641,5 +1648,6 @@
 
 void VidDevManager::switchDev(int dev_id,
-			      const VideoSwitchParam &param) throw(Error)
+			      const VideoSwitchParam &param)
+			      PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1679,5 +1687,5 @@
 void VidDevManager::setCaptureOrient(pjmedia_vid_dev_index dev_id,
     			  	     pjmedia_orient orient,
-    			  	     bool keep) throw(Error)
+    			  	     bool keep) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1867,5 +1875,5 @@
 
 void VideoMedia::registerMediaPort(MediaPort port, pj_pool_t *pool)
-     throw(Error)
+     PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1907,5 +1915,5 @@
 }
 
-VidConfPortInfo VideoMedia::getPortInfo() const throw(Error)
+VidConfPortInfo VideoMedia::getPortInfo() const PJSUA2_THROW(Error)
 {
     return VideoMedia::getPortInfoFromId(id);
@@ -1917,5 +1925,5 @@
 }
 
-VidConfPortInfo VideoMedia::getPortInfoFromId(int port_id) throw(Error)
+VidConfPortInfo VideoMedia::getPortInfoFromId(int port_id) PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO
@@ -1934,5 +1942,5 @@
 void VideoMedia::startTransmit(const VideoMedia &sink,
 			       const VideoMediaTransmitParam &param) const
-     throw(Error)
+     PJSUA2_THROW(Error)
 {
     PJ_UNUSED_ARG(param);
@@ -1945,5 +1953,6 @@
 }
 
-void VideoMedia::stopTransmit(const VideoMedia &sink) const throw(Error)
+void VideoMedia::stopTransmit(const VideoMedia &sink) const
+			      PJSUA2_THROW(Error)
 {
 #if PJSUA_HAS_VIDEO