Index: /pjproject/trunk/pjsip-apps/src/swig/importsym.py
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/importsym.py	(revision 6074)
+++ /pjproject/trunk/pjsip-apps/src/swig/importsym.py	(revision 6075)
@@ -56,5 +56,5 @@
 # Hardcoded!
 if sys.platform == 'win32':
-	PYCPARSER_DIR="C:/devs/tools/pycparser"
+	PYCPARSER_DIR="D:/work/tool/pycparser-master"
 elif sys.platform == "linux2":
 	PYCPARSER_DIR="/home/bennylp/Desktop/opt/src/pycparser-master"
Index: /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/CallActivity.java
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/CallActivity.java	(revision 6074)
+++ /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/CallActivity.java	(revision 6075)
@@ -143,5 +143,5 @@
         Display display;
         int rotation;
-        pjmedia_orient orient;
+        int orient;
 
         wm = (WindowManager)this.getSystemService(Context.WINDOW_SERVICE);
@@ -340,6 +340,6 @@
 	}
 
-	if (ci.getState().swigValue() <
-	    pjsip_inv_state.PJSIP_INV_STATE_CONFIRMED.swigValue())
+	if (ci.getState() <
+	    pjsip_inv_state.PJSIP_INV_STATE_CONFIRMED)
 	{
 	    if (ci.getRole() == pjsip_role_e.PJSIP_ROLE_UAS) {
@@ -351,6 +351,6 @@
 	    }
 	}
-	else if (ci.getState().swigValue() >=
-		 pjsip_inv_state.PJSIP_INV_STATE_CONFIRMED.swigValue())
+	else if (ci.getState() >=
+		 pjsip_inv_state.PJSIP_INV_STATE_CONFIRMED)
 	{
 	    buttonAccept.setVisibility(View.GONE);
Index: /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/MainActivity.java
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/MainActivity.java	(revision 6074)
+++ /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/MainActivity.java	(revision 6075)
@@ -583,5 +583,5 @@
     }
 
-    public void notifyRegState(pjsip_status_code code, String reason,
+    public void notifyRegState(int code, String reason,
 			       long expiration)
     {
@@ -592,5 +592,5 @@
 	    msg_str += "Registration";
 
-	if (code.swigValue()/100 == 2)
+	if (code/100 == 2)
 	    msg_str += " successful";
 	else
Index: /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/MyApp.java
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/MyApp.java	(revision 6074)
+++ /pjproject/trunk/pjsip-apps/src/swig/java/android/app/src/main/java/org/pjsip/pjsua2/app/MyApp.java	(revision 6075)
@@ -28,6 +28,5 @@
 interface MyAppObserver
 {
-    abstract void notifyRegState(pjsip_status_code code, String reason,
-				 long expiration);
+    abstract void notifyRegState(int code, String reason, long expiration);
     abstract void notifyIncomingCall(MyCall call);
     abstract void notifyCallState(MyCall call);
@@ -352,6 +351,6 @@
 	log_cfg.setWriter(logWriter);
 	log_cfg.setDecor(log_cfg.getDecor() & 
-			 ~(pj_log_decoration.PJ_LOG_HAS_CR.swigValue() | 
-			 pj_log_decoration.PJ_LOG_HAS_NEWLINE.swigValue()));
+			 ~(pj_log_decoration.PJ_LOG_HAS_CR | 
+			 pj_log_decoration.PJ_LOG_HAS_NEWLINE));
 
 	/* Write log to file (just uncomment whenever needed) */
Index: /pjproject/trunk/pjsip-apps/src/swig/java/sample.java
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/java/sample.java	(revision 6074)
+++ /pjproject/trunk/pjsip-apps/src/swig/java/sample.java	(revision 6075)
@@ -38,5 +38,5 @@
 	
 	@Override
-	public void notifyRegState(pjsip_status_code code, String reason, long expiration) {}
+	public void notifyRegState(int code, String reason, long expiration) {}
 	
 	@Override
Index: /pjproject/trunk/pjsip-apps/src/swig/pjsua2.i
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/pjsua2.i	(revision 6074)
+++ /pjproject/trunk/pjsip-apps/src/swig/pjsua2.i	(revision 6075)
@@ -68,4 +68,10 @@
 
 // Constants from PJSIP libraries
+
+#ifdef SWIGJAVA
+%include "enumtypeunsafe.swg"
+%javaconst(1);
+#endif
+
 %include "symbols.i"
 
Index: /pjproject/trunk/pjsip-apps/src/swig/symbols.i
===================================================================
--- /pjproject/trunk/pjsip-apps/src/swig/symbols.i	(revision 6074)
+++ /pjproject/trunk/pjsip-apps/src/swig/symbols.i	(revision 6075)
@@ -201,5 +201,5 @@
   PJ_TURN_TP_UDP = 17,
   PJ_TURN_TP_TCP = 6,
-  PJ_TURN_TP_TLS = 255
+  PJ_TURN_TP_TLS = 56
 } pj_turn_tp_type;
 
@@ -234,5 +234,7 @@
   PJMEDIA_EVENT_ORIENT_CHANGED = ((('T' << 24) | ('N' << 16)) | ('R' << 8)) | 'O',
   PJMEDIA_EVENT_RX_RTCP_FB = ((('B' << 24) | ('F' << 16)) | ('T' << 8)) | 'R',
-  PJMEDIA_EVENT_AUD_DEV_ERROR = ((('R' << 24) | ('R' << 16)) | ('E' << 8)) | 'A'
+  PJMEDIA_EVENT_AUD_DEV_ERROR = ((('R' << 24) | ('R' << 16)) | ('E' << 8)) | 'A',
+  PJMEDIA_EVENT_VID_DEV_ERROR = ((('R' << 24) | ('R' << 16)) | ('E' << 8)) | 'V',
+  PJMEDIA_EVENT_MEDIA_TP_ERR = ((('R' << 24) | ('R' << 16)) | ('E' << 8)) | 'T'
 } pjmedia_event_type;
 
@@ -827,7 +829,7 @@
 typedef enum pjsua_snd_dev_id
 {
-  PJSUA_SND_DEFAULT_CAPTURE_DEV = PJMEDIA_AUD_DEFAULT_CAPTURE_DEV,
-  PJSUA_SND_DEFAULT_PLAYBACK_DEV = PJMEDIA_AUD_DEFAULT_PLAYBACK_DEV,
-  PJSUA_SND_NO_DEV = PJMEDIA_AUD_INVALID_DEV,
+  PJSUA_SND_DEFAULT_CAPTURE_DEV = -1,
+  PJSUA_SND_DEFAULT_PLAYBACK_DEV = -2,
+  PJSUA_SND_NO_DEV = -3,
   PJSUA_SND_NULL_DEV = -99
 } pjsua_snd_dev_id;